#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

using namespace std;

const int maxn = 100;

string field[maxn];
int vis[maxn][maxn];
int n, m, L;

struct Solution
{
   string s, err_msg;
   int err_code;
   vector<pair<int, int> > v;

   Solution(ifstream &f)
   {
      err_code = 0;
      f >> s;
      if (s == "YES") {
         for (int i = 0; i < L; i++) {
            int j, k;
            f >> j >> k;
            v.push_back(make_pair(j, k));
         }
         if (!f) {
            err_code = 1;
            err_msg = "less then L points";
         }
         int x;
         f >> x;
         if (f) {
            err_code = 1;
            err_msg = "more then L points";
         }
      } else if (s == "NO") {
         //still ok 
      } else {
         err_code = 2;
         return;
      }
   }

   int ok()
   {
      if (err_code) return 0;
      memset(vis, 0, sizeof(vis));
      int i, j;

      for (i = 0; i < n; i++)
         for (j = 0; j < m; j++)
            if (field[i][j] == '#') {
               vis[2*i][2*j] = vis[2*i+1][2*j] = vis[2*i][2*j+1] = vis[2*i+1][2*j+1] = 1;
            }
      for (i = 0; i < L; i++) {
         int x = v[i].first, y = v[i].second;
         if (vis[x][y]) {
            err_code = 1;
            ostringstream ss; ss << i;
            err_msg = "snake hit wall of itself in index " + ss.str() + ", 0-based"; 
            return 0;
         }
         if (i && abs(x - v[i-1].first) + abs(y - v[i-1].second) > 1) {
            err_code = 1;
            ostringstream ss; ss << "(" << i-1 << ":" << i << ")";
            err_msg = "snake is not continous at indeces " + ss.str() + ", 0-based"; 
            return 0;
         }
      } 

      return 1;
   }
};

void botva(const char *msg)
{
   cout << msg;
}

int main(int argc, char* argv[])
{
   ifstream fin; ifstream fout; ifstream fans;
   fin.open(argv[1]); fout.open(argv[2]); fans.open(argv[3]);

   int i;
   fin >> n >> m >> L;
   for (i = 0; i < n; i++) fin >> field[i];

   Solution contestant(fout);
   Solution jury(fans);

   if (contestant.s == jury.s && jury.s == "NO") {
      botva("ok");
      return 0;
   }

   if (contestant.s == "YES" && !contestant.ok()) {botva(contestant.err_msg.c_str()); return contestant.err_code;}
   if (jury.s == "YES" && !jury.ok()) {botva(("Bad jury solution: " + jury.err_msg).c_str()); return 3;}

   if (contestant.s != jury.s) {
      if (contestant.s == "YES" && jury.s == "NO") {
         botva("jury didn't find solution, but contestant did");
         return 1;
      } else {
         botva("contestant didn't find solution");
         return 1;
      }
   }


   botva("ok");
   return 0;
}
