#include "easygen.h"
#include "easygen.cpp"

#include <algorithm>
#include <iostream>
#include <string>

using namespace std;

const int maxn = 50;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

int n, m;
string f[maxn];
int vis[maxn][maxn];

int valid(int i, int j)
{
   return (i >= 0 && i < n && j >= 0 && j < m) && f[i][j] == '.' && !vis[i][j];
}

int dfs(int i, int j)
{
   vis[i][j] = 1;
   int res = 1;
   for (int sc = 0; sc < 4; sc++) {
      int i1 = i + dx[sc], j1 = j + dy[sc];
      if (valid(i1, j1)) res += dfs(i1, j1);
   }
   return res;
}

int main(int argc, char* argv[])
{
   int i, j;

   try {
      testInfo a(argc, argv);
      n = a.getIntParam("N");
      m = a.getIntParam("M");
      double p = a.getFloatParam("p");
      int addon = a.getIntParam("addon");

      for (i = 0; i < n; i++) {
         string s;
         for (j = 0; j < m; j++) s += genRandFloat(0, 1, 2) < p ? '#' : '.';
         a["a"][i+1]["s"] = f[i] = s;
      }

      int best = 0; 
      for (i = 0; i < n; i++) {
         for (j = 0; j < m; j++) {
            if (f[i][j] == '.' && !vis[i][j]) {
               int cur = dfs(i, j);
               if (cur > best) {
                  best = cur;
               }
            }
         }   
      }

      a["L"] = best*4 + addon;
            
   } catch (genError a) {
      cout << a.err();
   }
   return 0;
}