#include <vector>
#include <string>
#include <iostream>
#include <algorithm>

using namespace std;

#define PB push_back
#define PII pair<int, int>
#define A first
#define B second

const int maxn = 100;
const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};
const int sx[] = {0, 1, 1, 0};
const int sy[] = {1, 1, 0, 0};

int n, m, L;
string s[maxn];
int vis[maxn][maxn];
vector<PII> ans;
int last_i, last_j, last_d, first_d;

int valid(int i, int j)
{
   return (i >= 0 && i < n && j >= 0 && j < m) && s[i][j] == '.' && !vis[i][j];
}

int dfs(int i, int j)
{
   vis[i][j] = 1;
   int res = 1;
   for (int sc = 0; sc < 4; sc++) {
      int i1 = i + dx[sc], j1 = j + dy[sc];
      if (valid(i1, j1)) res += dfs(i1, j1);
   }
   return res;
}

void prelim(int i, int j, int d)
{
   if (last_d < 0) return;
   if (last_d == (d+1) % 4) {
      //turn left
      ans.PB(PII(last_i*2 + sx[last_d] + 2*dx[last_d], last_j*2 + sy[last_d] + 2*dy[last_d]));
   }
   if (last_d == (d+2) % 4) {
      //turn back
      ans.PB(PII(last_i*2 + sx[last_d] + 2*dx[last_d], last_j*2 + sy[last_d] + 2*dy[last_d]));
      ans.PB(PII(i*2 + sx[d] - dx[d], j*2 + sy[d] - dy[d]));
   }
}

void go(int i, int j, int d)
{
   prelim(i, j, d);
   last_i = i; last_j = j; last_d = d;
   i = i*2 + sx[d]; j = j*2 + sy[d];
   ans.PB(PII(i, j));
   ans.PB(PII(i + dx[d], j + dy[d]));
}

void dfs1(int i, int j, int root, int dir)
{
   vis[i][j] = 1;
   for (int dif = 1 + root; dif >= -1; dif--) {
      int sc = (dir + dif + 4) % 4;
      int i1 = i + dx[sc], j1 = j + dy[sc];
      if (valid(i1, j1)) {
         if (root && last_d < 0) first_d = sc;
         go(i, j, sc);
         dfs1(i1, j1, 0, sc);
         go(i1, j1, (sc+2) % 4);
      }
   }
}

int main()
{
   freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);
   
   int i, j; 
   cin >> n >> m >> L;
   for (i = 0; i < n; i++) {
      cin >> s[i];
   }
   int best = 0; 
   int x, y;
   for (i = 0; i < n; i++) {
      for (j = 0; j < m; j++) {
         if (s[i][j] == '.' && !vis[i][j]) {
            int cur = dfs(i, j);
            if (cur > best) {
               best = cur;
               x = i; y = j;
            }
         }
      }   
   }
   
   if (best*4 >= L) {
      cout << "YES" << endl; 
      memset(vis, 0, sizeof(vis));
      if (best == 1) {
         ans.PB(PII(2*x, 2*y));
         ans.PB(PII(2*x+1, 2*y));
         ans.PB(PII(2*x+1, 2*y+1));
         ans.PB(PII(2*x, 2*y+1));
      } else {
         last_d = -1;
         dfs1(x, y, 1, 0);
         prelim(x, y, first_d);
      }   
      unique(ans.begin(), ans.end());
      for (i = 0; i < L; i++) 
         cout << ans[i].A << " " << ans[i].B << endl;
   } else cout << "NO";

   fclose(stdin); fclose(stdout);
   return 0;   
}
